/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
)

// ServicesGoogleAnalyticsCustomApiService ServicesGoogleAnalyticsCustomApi service
type ServicesGoogleAnalyticsCustomApiService service

type ApiAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest struct {
	ctx                                                                                      context.Context
	ApiService                                                                               *ServicesGoogleAnalyticsCustomApiService
	appAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest *AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest
}

//
func (r ApiAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest(appAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) ApiAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest {
	r.appAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest = &appAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest
	return r
}

func (r ApiAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) Execute() (*GoogleAnalyticsCustomUserAuth, *http.Response, error) {
	return r.ApiService.AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackExecute(r)
}

/*
AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallback Processes callback URL

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest
*/
func (a *ServicesGoogleAnalyticsCustomApiService) AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallback(ctx context.Context) ApiAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest {
	return ApiAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return GoogleAnalyticsCustomUserAuth
func (a *ServicesGoogleAnalyticsCustomApiService) AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackExecute(r ApiAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest) (*GoogleAnalyticsCustomUserAuth, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue *GoogleAnalyticsCustomUserAuth
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ServicesGoogleAnalyticsCustomApiService.AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallback")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/services/google_analytics_custom/oauth-process-callback"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.appAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest == nil {
		return localVarReturnValue, nil, reportError("appAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.appAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthCallbackRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest struct {
	ctx                                                                                 context.Context
	ApiService                                                                          *ServicesGoogleAnalyticsCustomApiService
	appAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest *AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest
}

//
func (r ApiAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest) AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest(appAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest) ApiAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest {
	r.appAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest = &appAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest
	return r
}

func (r ApiAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest) Execute() (*GoogleAnalyticsCustomUserAuth, *http.Response, error) {
	return r.ApiService.AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlExecute(r)
}

/*
AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrl Builds redirect URL

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest
*/
func (a *ServicesGoogleAnalyticsCustomApiService) AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrl(ctx context.Context) ApiAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest {
	return ApiAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return GoogleAnalyticsCustomUserAuth
func (a *ServicesGoogleAnalyticsCustomApiService) AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlExecute(r ApiAppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest) (*GoogleAnalyticsCustomUserAuth, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue *GoogleAnalyticsCustomUserAuth
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ServicesGoogleAnalyticsCustomApiService.AppAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrl")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/services/google_analytics_custom/oauth-request-url"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.appAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest == nil {
		return localVarReturnValue, nil, reportError("appAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.appAuthorizerGoogleAnalyticsCustomGoogleAnalyticsCustomAuthorizerNewOAuthUrlRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
